// glslv output by Cg compiler
// cgc version 2.1.0017, build date Feb 17 2009
// command line args: -profile glslv
// source file: ../InteriorMapping/Media/InteriorMapping.cg
//vendor NVIDIA Corporation
//version 2.1.0.17
//profile glslv
//program IM_FullyTexturedRooms_FP
//semantic IM_FullyTexturedRooms_FP.ceilingTexture
//semantic IM_FullyTexturedRooms_FP.floorTexture
//semantic IM_FullyTexturedRooms_FP.wallXYTexture
//semantic IM_FullyTexturedRooms_FP.wallZYTexture
//semantic IM_FullyTexturedRooms_FP.wallFrequencies
//semantic IM_FullyTexturedRooms_FP.cameraPosition
//var sampler2D ceilingTexture :  : _ZZ3SceilingTexture : 2 : 1
//var sampler2D floorTexture :  : _ZZ3SfloorTexture : 3 : 1
//var sampler2D wallXYTexture :  : _ZZ3SwallXYTexture : 4 : 1
//var sampler2D wallZYTexture :  : _ZZ3SwallZzYTexture : 5 : 1
//var float3 wallFrequencies :  : _ZZ3SwallFrequencies : 6 : 1
//var float3 cameraPosition :  : _ZZ3ScameraPosition : 7 : 1
//var float3 position : $vin.TEXCOORD1 : TEXCOORD1 : 0 : 1
//var float4 oColour : $vout.COLOR : COLOR : 1 : 1

uniform sampler2D _ZZ3SceilingTexture;
uniform sampler2D _ZZ3SfloorTexture;
uniform sampler2D _ZZ3SwallXYTexture;
uniform sampler2D _ZZ3SwallZzYTexture;
uniform vec3 _ZZ3SwallFrequencies;
uniform vec3 _ZZ3ScameraPosition;
vec3 _ZZ3SdirectionZh0009;
vec3 _ZZ3SwallsZh0009;
vec3 _ZZ3SrayFractionsZh0009;
vec2 _ZZ3SintersectionXYZh0009;
vec2 _ZZ3SintersectionXZzZh0009;
vec2 _ZZ3SintersectionZzYZh0009;
vec4 _ZZ3SceilingColourZh0009;
vec4 _ZZ3SfloorColourZh0009;
vec4 _ZZ3SverticalColourZh0009;
vec4 _ZZ3SwallXYColourZh0009;
vec4 _ZZ3SwallZzYColourZh0009;
float _ZZ3SxVSzZh0009;
vec4 _ZZ3SinteriorColourZh0009;
float _ZZ3SrayFraction_xVSzZh0009;
float _ZZ3SxzVSyZh0009;
vec3 _ZZ3SxZh0011;
float _ZZ3StZh0021;

 // main procedure, the original name was IM_FullyTexturedRooms_FP
void main()
{

    vec4 _ZZ4SoColour;

    _ZZ3SdirectionZh0009 = gl_MultiTexCoord1.xyz - _ZZ3ScameraPosition;
    _ZZ3SxZh0011 = gl_MultiTexCoord1.xyz*_ZZ3SwallFrequencies;
    _ZZ3SwallsZh0009 = (floor(_ZZ3SxZh0011) + vec3(float((_ZZ3SdirectionZh0009.x >= 0.00000000E+00)), float((_ZZ3SdirectionZh0009.y >= 0.00000000E+00)), float((_ZZ3SdirectionZh0009.z >= 0.00000000E+00))))/_ZZ3SwallFrequencies;
    _ZZ3SrayFractionsZh0009 = (vec3(_ZZ3SwallsZh0009.x, _ZZ3SwallsZh0009.y, _ZZ3SwallsZh0009.z) - _ZZ3ScameraPosition)/_ZZ3SdirectionZh0009;
    _ZZ3SintersectionXYZh0009 = 4.00000000E+00*(_ZZ3ScameraPosition + _ZZ3SrayFractionsZh0009.z*_ZZ3SdirectionZh0009).xy;
    _ZZ3SintersectionXZzZh0009 = 4.00000000E+00*(_ZZ3ScameraPosition + _ZZ3SrayFractionsZh0009.y*_ZZ3SdirectionZh0009).xz;
    _ZZ3SintersectionZzYZh0009 = 4.00000000E+00*(_ZZ3ScameraPosition + _ZZ3SrayFractionsZh0009.x*_ZZ3SdirectionZh0009).zy;
    _ZZ3SceilingColourZh0009 = texture2D(_ZZ3SceilingTexture, _ZZ3SintersectionXZzZh0009);
    _ZZ3SfloorColourZh0009 = texture2D(_ZZ3SfloorTexture, _ZZ3SintersectionXZzZh0009);
    _ZZ3StZh0021 = float((_ZZ3SdirectionZh0009.y >= 0.00000000E+00));
    _ZZ3SverticalColourZh0009 = _ZZ3SfloorColourZh0009 + _ZZ3StZh0021*(_ZZ3SceilingColourZh0009 - _ZZ3SfloorColourZh0009);
    _ZZ3SwallXYColourZh0009 = texture2D(_ZZ3SwallXYTexture, _ZZ3SintersectionXYZh0009);
    _ZZ3SwallZzYColourZh0009 = texture2D(_ZZ3SwallZzYTexture, _ZZ3SintersectionZzYZh0009);
    _ZZ3SxVSzZh0009 = float((_ZZ3SrayFractionsZh0009.z >= _ZZ3SrayFractionsZh0009.x));
    _ZZ3SinteriorColourZh0009 = _ZZ3SwallXYColourZh0009 + _ZZ3SxVSzZh0009*(_ZZ3SwallZzYColourZh0009 - _ZZ3SwallXYColourZh0009);
    _ZZ3SrayFraction_xVSzZh0009 = _ZZ3SrayFractionsZh0009.z + _ZZ3SxVSzZh0009*(_ZZ3SrayFractionsZh0009.x - _ZZ3SrayFractionsZh0009.z);
    _ZZ3SxzVSyZh0009 = float((_ZZ3SrayFractionsZh0009.y >= _ZZ3SrayFraction_xVSzZh0009));
    _ZZ3SinteriorColourZh0009 = _ZZ3SverticalColourZh0009 + _ZZ3SxzVSyZh0009*(_ZZ3SinteriorColourZh0009 - _ZZ3SverticalColourZh0009);
    _ZZ4SoColour = _ZZ3SinteriorColourZh0009;
    gl_FrontColor = _ZZ3SinteriorColourZh0009;
} // main end
