#ifndef _TEX_H_
#define _TEX_H_

#include <stdlib.h>
#include <GL/glut.h>
#include <stdio.h>


#define glMultiTexCoord2f	glMultiTexCoord2fARB
#define glActiveTexture		glActiveTextureARB



using namespace std;

/*data structure for the image used for  texture mapping */
typedef struct Image {
  unsigned long sizeX;
  unsigned long sizeY;
  char *data;
} Image;

extern Image *TextureImage;

typedef struct RGB {
  GLubyte r;
  GLubyte g; 
  GLubyte b;
} RGB;

//RGB myimage[64][64];
extern RGB* pixel;

//forward declaration of image loading and texture set-up code
int ImageLoad(char *filename, Image *image);
GLvoid LoadTexture(char* image_file, int tex_id);
void init_tex();


typedef struct {
   unsigned char r;
   unsigned char g;
   unsigned char b;
   unsigned char a;
} PIXEL;

typedef struct {
   char  idlength;
   char  colourmaptype;
   char  datatypecode;
   short int colourmaporigin;
   short int colourmaplength;
   char  colourmapdepth;
   short int x_origin;
   short int y_origin;
   short width;
   short height;
   char  bitsperpixel;
   char  imagedescriptor;
   PIXEL* pixels;
} TGA;


TGA * readTga(std::string filename);


#endif

